swh/web/alter/urls.py
# Copyright (C) 2025  The Software Heritage developers
# See the AUTHORS file at the top-level directory of this distribution
# License: GNU Affero General Public License version 3, or any later version
# See top-level LICENSE file for more information

from django.urls import path

from .views import (
    admin_alteration,
    admin_dashboard,
    admin_event,
    admin_message,
    admin_origin,
    alteration_access,
    alteration_details,
    alteration_link,
    alteration_message,
    assistant_category,
    assistant_email,
    assistant_email_verification,
    assistant_origins,
    assistant_reasons,
    assistant_summary,
    content_policies,
)

urlpatterns = [
    path("content-policies/", content_policies, name="content-policies"),
    path("alteration/email/", assistant_email, name="alteration-email"),
    path(
        "alteration/email/verification/<str:value>/",
        assistant_email_verification,
        name="alteration-email-verification",
    ),
    path("alteration/category/", assistant_category, name="alteration-category"),
    path("alteration/origins/", assistant_origins, name="alteration-origins"),
    path("alteration/reasons/", assistant_reasons, name="alteration-reasons"),
    path("alteration/summary/", assistant_summary, name="alteration-summary"),
    path("alteration/<uuid:pk>/", alteration_details, name="alteration-details"),
    path(
        "alteration/<uuid:pk>/message/", alteration_message, name="alteration-message"
    ),
    path("alteration/<uuid:pk>/access/", alteration_access, name="alteration-access"),
    path("alteration/link/<str:value>/", alteration_link, name="alteration-link"),
    path("admin/alteration/", admin_dashboard, name="alteration-dashboard"),
    path("admin/alteration/<uuid:pk>/", admin_alteration, name="alteration-admin"),
    path(
        "admin/alteration/<uuid:alteration_pk>/origin/<uuid:pk>/",
        admin_origin,
        name="alteration-origin-admin",
    ),
    path(
        "admin/alteration/<uuid:alteration_pk>/origin/",
        admin_origin,
        name="alteration-origin-admin-create",
    ),
    path(
        "admin/alteration/<uuid:pk>/message/",
        admin_message,
        name="alteration-message-admin",
    ),
    path(
        "admin/alteration/<uuid:alteration_pk>/event/<uuid:pk>/",
        admin_event,
        name="alteration-event-admin",
    ),
]

swh/web/urls.py
# Copyright (C) 2017-2024  The Software Heritage developers
# See the AUTHORS file at the top-level directory of this distribution
# License: GNU Affero General Public License version 3, or any later version
# See top-level LICENSE file for more information

from importlib.util import find_spec
from typing import List, Union

from django.conf import settings
from django.conf.urls import handler400, handler403, handler404, handler500, include
from django.contrib.staticfiles.views import serve
from django.urls import URLPattern, URLResolver
from django.urls import re_path as url

from swh.web.config import get_config
from swh.web.utils.exc import swh_handle400, swh_handle403, swh_handle404, swh_handle500

swh_web_config = get_config()


urlpatterns: List[Union[URLPattern, URLResolver]] = []

# Register URLs for each SWH Django application
for app in settings.SWH_DJANGO_APPS:
    app_urls = app + ".urls"
    try:
        app_urls_spec = find_spec(app_urls)
        if app_urls_spec is not None:
            urlpatterns.append(url(r"^", include(app_urls)))
    except ModuleNotFoundError:
        assert False, f"Django application {app} not found !"


# allow to serve assets through django staticfiles
# even if settings.DEBUG is False
def insecure_serve(request, path, **kwargs):
    return serve(request, path, insecure=True, **kwargs)


# enable to serve compressed assets through django development server
if swh_web_config["serve_assets"]:
    static_pattern = r"^%s(?P<path>.*)$" % settings.STATIC_URL[1:]
    urlpatterns.append(url(static_pattern, insecure_serve, name="insecure-serve"))


handler400 = swh_handle400  # noqa
handler403 = swh_handle403  # noqa
handler404 = swh_handle404  # noqa
handler500 = swh_handle500  # noqa

swh/web/alter/models.py
# Copyright (C) 2025  The Software Heritage developers
# See the AUTHORS file at the top-level directory of this distribution
# License: GNU Affero General Public License version 3, or any later version
# See top-level LICENSE file for more information

from __future__ import annotations

from datetime import timedelta
from typing import TYPE_CHECKING, Any, Union
import uuid

from django.conf import settings
from django.core.exceptions import ValidationError
from django.core.validators import validate_domain_name, validate_email
from django.db import IntegrityError, models, transaction
from django.db.models import Q
from django.db.models.query import QuerySet
from django.urls import reverse
from django.utils import timezone
from django.utils.crypto import get_random_string
from django.utils.translation import gettext as _

from .apps import APP_LABEL

if TYPE_CHECKING:
    from django.contrib.sessions.backends.base import SessionBase


class BaseModel(models.Model):
    """An abstract base model to provide UUID pks and timestamps."""

    id = models.UUIDField(primary_key=True, default=uuid.uuid4, editable=False)
    """UUID primary key"""

    created_at = models.DateTimeField(_("created"), auto_now_add=True)
    """Creation date"""

    updated_at = models.DateTimeField(_("updated"), auto_now=True)
    """Last update"""

    class Meta:
        abstract = True


class OriginOutcome(models.TextChoices):
    VALIDATING = "validating", _("Validating")
    REJECTED = "rejected", _("Rejected")
    MAILMAP = "mailmap", _("Mailmap")
    MASK = "mask", _("Permanent mask")
    TAKEDOWN = "takedown", _("Takedown")
    BLOCK = "block", _("Takedown and block")


class OriginOwnership(models.TextChoices):
    UNKNOWN = "unknown", _("?")
    OWNER = "owner", _("Requester is the owner of the origin")
    FORK = "fork", _("Fork of an origin owned by the requester")
    OTHER = "other", _("Origin has no direct link with the requester")


class Origin(BaseModel):
    """Origins concerned by an `Alteration`."""

    url = models.URLField(_("URL"))
    """Origin's URL"""

    alteration = models.ForeignKey(
        "Alteration",
        related_name="origins",
        on_delete=models.RESTRICT,
        null=False,
    )
    """Alteration FK"""

    outcome = models.CharField(
        _("outcome"),
        max_length=20,
        choices=OriginOutcome,
        default=OriginOutcome.VALIDATING,
    )
    """Outcome for this origin"""

    reason = models.TextField(_("reason for this outcome"), blank=True)
    """Outcome's reason"""

    code_license = models.TextField(_("license found in code"), blank=True)
    """License found in / guessed from the source code"""

    available = models.BooleanField(
        _("available"),
        help_text=_("Is this URL is still available online ?"),
        null=True,
    )
    """URL is still available"""

    ownership = models.CharField(
        _("owner"),
        help_text=_("Is Requester the owner of this origin or is it a fork ?"),
        max_length=20,
        choices=OriginOwnership,
        default=OriginOwnership.UNKNOWN,
    )
    """Is Requester the owner of this origin or is it a fork"""

    class Meta:
        app_label = APP_LABEL
        db_table = "origin"
        indexes = [models.Index(fields=["url"])]
        constraints = [
            models.UniqueConstraint(fields=["alteration_id", "url"], name="unique_url"),
        ]

    def __repr__(self) -> str:
        return f"<Origin: {self.url} ({self.pk})>"

    def __str__(self) -> str:
        return self.url

    def get_admin_url(self):
        return reverse(
            "alteration-origin-admin",
            kwargs={"pk": self.pk, "alteration_pk": self.alteration_id},
        )


class AlterationManager(models.Manager["Alteration"]):
    """Custom ``Alteration`` manager."""

    def search(self, query: str) -> QuerySet[Alteration, Alteration]:
        """A basic search for requests.

        Will find requests where `query` is to be found (case insensitive) in either:
        * its ``reasons`` field
        * its ``expected_outcome`` field
        * one of its ``Origin`` url
        * Requester's email

        Args:
            query: search query
        """
        base_queryset = super().get_queryset()
        search_filters = (
            Q(reasons__icontains=query)
            | Q(expected_outcome__icontains=query)
            | Q(origins__url__icontains=query)
            | Q(email__icontains=query)
        )
        return base_queryset.filter(search_filters).distinct()


class AlterationStatus(models.TextChoices):
    VALIDATING = "validating", _("Validating")
    PLANNING = "planning", _("Planning")
    EXECUTING = "executing", _("Executing")
    PROCESSED = "processed", _("Processed")
    REJECTED = "rejected", _("Rejected")
    CLOSED = "closed", _("Closed")
    ARCHIVED = "archived", _("Archived")

    __empty__ = _("Filter by status")


class AlterationCategory(models.TextChoices):
    COPYRIGHT = "copyright", _("Copyright / License infringement")
    PII = "pii", _("Personal Identifiable Information")
    LEGAL = "legal", _("Other legal matters")

    __empty__ = _("Filter by category")


class Alteration(BaseModel):
    """An alteration request."""

    status = models.CharField(
        _("status"),
        max_length=20,
        choices=AlterationStatus,
        default=AlterationStatus.VALIDATING,
    )
    """Progression indicator"""

    category = models.CharField(
        _("category"), max_length=20, choices=AlterationCategory
    )
    """The category/type of this alteration"""

    reasons = models.TextField(_("reasons"), null=False)
    """The alteration request reasons"""

    expected_outcome = models.TextField(_("expected outcome"), null=False)
    """The Requester expectations"""

    email = models.EmailField(_("requester's email"))
    """Requester's email"""

    objects = AlterationManager()

    class Meta:
        app_label = APP_LABEL
        db_table = "alteration"
        ordering = ["-created_at"]

    def get_absolute_url(self):
        return reverse("alteration-details", kwargs={"pk": self.pk})

    def get_admin_url(self):
        return reverse("alteration-admin", kwargs={"pk": self.pk})

    @classmethod
    def create_from_assistant(cls, session: SessionBase) -> Alteration:
        """Create an alteration request from the alteration request assistant.

        Email notifications are sent to the requester & operators.

        Args:
            session: django's session store

        Returns:
            an Alteration instance

        Raises:
            DatabaseError: something went wrong while creating objects in the database
        """
        with transaction.atomic():
            alteration = Alteration.objects.create(
                category=session["alteration_category"],
                reasons=session["alteration_reasons"],
                expected_outcome=session["alteration_expected_outcome"],
                email=session["alteration_email"],
            )
            Origin.objects.bulk_create(
                [
                    Origin(alteration=alteration, url=url)
                    for url in session["alteration_origins"]
                ]
            )
            Event.objects.create(
                alteration=alteration,
                category=EventCategory.LOG,
                author=_("Requester"),
                content=_("Alteration request created."),
                internal=False,
            )
        return alteration

    @property
    def is_read_only(self) -> bool:
        return self.status == AlterationStatus.ARCHIVED

    def __repr__(self) -> str:
        return f"<Alteration: {self.category} [{self.email}] ({self.pk})>"

    def __str__(self) -> str:
        return f"{self.get_category_display()} by {self.email}"


class EventRecipient(models.TextChoices):
    REQUESTER = "requester", _("Requester")
    SUPPORT = "support", _("Support")
    MANAGER = "manager", _("Manager")
    LEGAL = "legal", _("Legal")
    TECHNICAL = "technical", _("Technical")


class EventCategory(models.TextChoices):
    LOG = "log", _("Event")
    MESSAGE = "message", _("Message")


class EventManager(models.Manager["Event"]):
    """Custom ``Event`` manager."""

    def get_queryset(self) -> QuerySet[Event, Event]:
        """Filters internal events.

        Returns:
            An ``Event`` queryset with ``internal`` events filtered out.
        """
        return super().get_queryset().filter(internal=False)


class Event(BaseModel):
    """An event on an `Alteration`.

    An event could be
    * a log of a status change or a modification of any another field / Origin
    * a message between recipients
    """

    alteration = models.ForeignKey(
        "Alteration",
        related_name="events",
        on_delete=models.RESTRICT,
        null=False,
    )
    """Alteration FK"""

    category = models.CharField(_("category"), max_length=20, choices=EventCategory)
    """Category/type of event"""

    author = models.CharField(_("author"), max_length=200, blank=True)
    """The name of the author of this event"""

    recipient = models.CharField(
        _("recipient role"), max_length=20, choices=EventRecipient, blank=True
    )
    """The role targeted by this event, a value is required to send notifications"""

    content = models.TextField(_("content"), blank=True)
    """The event's textual content"""

    internal = models.BooleanField(
        _("internal"),
        default=True,
        help_text=_(
            "Internal messages are not visible in the Requester activity log to avoid "
            "unnecessary noise, they must not be used for confidential exchanges "
            "between team members and could be requested by the user."
        ),
    )
    """Internal actions are not visible to the Requester"""

    objects = models.Manager()
    public_objects = EventManager()

    class Meta:
        app_label = APP_LABEL

swh/web/alter/templates/includes/activity_log.html
{% comment %}
# Copyright (C) 2025  The Software Heritage developers
# See the AUTHORS file at the top-level directory of this distribution
# License: GNU Affero General Public License version 3, or any later version
# See top-level LICENSE file for more information
{% endcomment %}

<ul class="list-group" id="alteration-events">
  {% for event in events %}
    <li class="list-group-item {% if event.category != "log" %}list-group-item-light{% endif %}"
        id="event-{{ event.pk }}"
        itemscope
        itemtype="https://schema.org/Message">
      <div>
        {% if ALTER_ADMIN_PERMISSION in perms %}
          <button class="btn btn-secondary btn-sm float-end"
                  aria-label="{% translate "Edit" %}"
                  data-bs-toggle="modal"
                  data-bs-target="#event-{{ event.pk }}-modal">
            <span class="mdi mdi-pen"></span>
          </button>
        {% endif %}
        <span itemprop="text">{{ event.content|linebreaks }}</span>
      </div>
      <div class="d-flex w-100 justify-content-between">
        <small>
          {% if event.category == "message" %}
            <i class="mdi mdi-forum"></i>
            <span itemprop="genre">{{ event.get_category_display }}</span> by <span itemprop="sender">{{ event.author|default:"system" }}</span> to <span itemprop="recipient">{{ event.get_recipient_display|default:"?" }}</span>
          {% elif event.category == "log" %}
            <i class="mdi mdi-calendar-text"></i>
            <span itemprop="genre">{{ event.get_category_display }}</span> by <span itemprop="sender">{{ event.author|default:"System" }}</span>
          {% endif %}
        </small>
        <small>
          {% if ALTER_ADMIN_PERMISSION in perms %}
            <span class="mdi {% if event.internal %}mdi-volume-mute{% else %}mdi-web{% endif %}"
                  title="{% if event.internal %}{{ _("Internal event") }}{% else %}{{ _("Public event") }}{% endif %}"
                  itemprop="conditionsOfAccess"></span>
          {% endif %}
          <time itemprop="dateCreated" datetime="{{ event.created_at }}">{{ event.created_at|date:"SHORT_DATETIME_FORMAT" }}</time>
        </small>
      </div>
    </li>
  {% endfor %}
</ul>

swh/web/alter/templates/includes/origins_table.html
{% comment %}
# Copyright (C) 2025  The Software Heritage developers
# See the AUTHORS file at the top-level directory of this distribution
# License: GNU Affero General Public License version 3, or any later version
# See top-level LICENSE file for more information
{% endcomment %}

{% load alter_extras %}

<table class="table swh-table swh-table-striped" id="alteration-origins">
  <thead>
    <tr class="text-nowrap">
      <th class="w-100">{% translate "URL" %}</th>
      <th>{% translate "Status" %}</th>
      <th>{% translate "Licence" %}</th>
      <th>{% translate "Online" %}</th>
      <th>{% translate "Owner" %}</th>
      <th>{% translate "Updated" %}</th>
      {% if ALTER_ADMIN_PERMISSION in perms %}
        <th>
          <span class="visually-hidden">{% translate "Actions" %}</span>
        </th>
      {% endif %}
    </tr>
  </thead>
  <tbody>
    {% for origin in origins %}
      <tr itemscope>
        <td class="text-break">
          <a href="{{ origin.url }}" target="_blank" itemprop="url">{{ origin.url }}</a>
          {% if origin.reason %}
            <p class="mb-0" itemprop="reason">
              {% blocktranslate with reason=origin.reason|linebreaksbr trimmed %}
                Reason: {{ reason }}
              {% endblocktranslate %}
            </p>
          {% endif %}
        </td>
        <td itemprop="outcome">{{ origin.outcome|outcome_badge:origin.get_outcome_display }}</td>
        <td itemprop="license">{{ origin.code_license|default:"?" }}</td>
        <td itemprop="available">{{ origin.available|yesno:"✓,✕,?" }}</td>
        <td itemprop="ownership">{{ origin.get_ownership_display }}</td>
        <td itemprop="dateModified">{{ alteration.updated_at|date:"SHORT_DATE_FORMAT" }}</td>
        {% if ALTER_ADMIN_PERMISSION in perms %}
          <td>
            <div class="btn-group" aria-label="Actions for {{ origin }}">
              <button class="btn btn-light btn-sm"
                      data-bs-toggle="modal"
                      data-bs-target="#origin-{{ origin.pk }}"
                      aria-label="{% translate "Edit" %}">
                <span class="mdi mdi-link-edit"></span>
              </button>
              <button class="btn btn-light btn-sm btn-clipboard"
                      data-bs-toggle="tooltip"
                      data-bs-trigger="manual"
                      data-bs-title="{{ _("Copied Origin URL") }}"
                      data-url="{{ origin.url }}"
                      aria-label="{% translate "Copy" %}">
                <span class="mdi mdi-content-copy"></span>
              </button>
            </div>
          </td>
        {% endif %}
      </tr>
    {% empty %}
      <tr>
        <td colspan="{% if "swh.web.alter" in perms %}7{% else %}6{% endif %}">
          <em>{% translate "none" %}</em>
        </td>
      </tr>
    {% endfor %}
  </tbody>
</table>

swh/web/alter/templates/includes/reasons_outcome.html
{% comment %}
# Copyright (C) 2025  The Software Heritage developers
# See the AUTHORS file at the top-level directory of this distribution
# License: GNU Affero General Public License version 3, or any later version
# See top-level LICENSE file for more information
{% endcomment %}

<div class="row mt-3 gx-5">
  <div class="col-sm-6 mb-3 mb-sm-0">
    <div class="card h-100" id="alteration-reasons">
      <div class="card-header">{% translate "Reasons" %}</div>
      <div class="card-body">
        <div class="card-text">{{ alteration.reasons|linebreaks }}</div>
      </div>
    </div>
  </div>
  <div class="col-sm-6 mb-3 mb-sm-0">
    <div class="card h-100" id="alteration-expected-outcome">
      <div class="card-header">{% translate "Expected outcome" %}</div>
      <div class="card-body">{{ alteration.expected_outcome|linebreaks }}</div>
    </div>
  </div>
</div>

swh/web/alter/templates/includes/steps.html
{% comment %}
# Copyright (C) 2025  The Software Heritage developers
# See the AUTHORS file at the top-level directory of this distribution
# License: GNU Affero General Public License version 3, or any later version
# See top-level LICENSE file for more information
{% endcomment %}

<nav class="process-steps list-group list-group-horizontal mb-3 d-none d-md-flex">
  <a class="list-group-item list-group-item-action {% if process.email.active %}active{% endif %}"
     href="{{ process.email.url }}"
     {% if process.email.active %}aria-current="true"{% endif %}
     id="alter-step-email">
    <div class="media flex-sm-column align-items-sm-center flex-xl-row">
      <i class="mdi mdi-email-check mr-0 mr-xl-3" aria-hidden="true"></i>
      <div class="media-body">
        <strong class="d-none d-xl-block">{% translate "Step 1" %}</strong>
        {% translate "Email" %}
      </div>
    </div>
  </a>
  <a class="list-group-item list-group-item-action {% if process.category.active %}active{% elif process.category.disabled %}disabled{% endif %}"
     href="{{ process.category.url }}"
     {% if process.category.active %}aria-current="true"{% elif process.category.disabled %}aria-disabled="true"{% endif %}
     id="alter-step-category">
    <div class="media flex-sm-column align-items-sm-center flex-xl-row">
      <i class="mdi mdi-shape mr-0 mr-xl-3" aria-hidden="true"></i>
      <div class="media-body">
        <strong class="d-none d-xl-block">{% translate "Step 2" %}</strong>
        {% translate "Category" %}
      </div>
    </div>
  </a>
  <a class="list-group-item list-group-item-action {% if process.origins.active %}active{% elif process.origins.disabled %}disabled{% endif %}"
     href="{{ process.origins.url }}"
     {% if process.origins.active %}aria-current="true"{% elif process.origins.disabled %}aria-disabled="true"{% endif %}
     id="alter-step-origins">
    <div class="media flex-sm-column align-items-sm-center flex-xl-row">
      <i class="mdi mdi-magnify mr-0 mr-xl-3" aria-hidden="true"></i>
      <div class="media-body">
        <strong class="d-none d-xl-block">{% translate "Step 3" %}</strong>
        {% translate "Origins" %}
      </div>
    </div>
  </a>
  <a class="list-group-item list-group-item-action {% if process.reasons.active %}active{% elif process.reasons.disabled %}disabled{% endif %}"
     href="{{ process.reasons.url }}"
     {% if process.reasons.active %}aria-current="true"{% elif process.reasons.disabled %}aria-disabled="true"{% endif %}
     id="alter-step-reasons">
    <div class="media flex-sm-column align-items-sm-center flex-xl-row">
      <i class="mdi mdi-chat-question mr-0 mr-xl-3" aria-hidden="true"></i>
      <div class="media-body">
        <strong class="d-none d-xl-block">{% translate "Step 4" %}</strong>
        {% translate "Reasons" %}
      </div>
    </div>
  </a>
  <a class="list-group-item list-group-item-action {% if process.summary.active %}active{% elif process.summary.disabled %}disabled{% endif %}"
     href="{{ process.summary.url }}"
     {% if process.summary.active %}aria-current="true"{% elif process.summary.disabled %}aria-disabled="true"{% endif %}
     id="alter-step-summary">
    <div class="media flex-sm-column align-items-sm-center flex-xl-row">
      <i class="mdi mdi-file-sign mr-0 mr-xl-3" aria-hidden="true"></i>
      <div class="media-body">
        <strong class="d-none d-xl-block">{% translate "Step 5" %}</strong>
        {% translate "Summary" %}
      </div>
    </div>
  </a>
</nav>

swh/web/alter/templates/includes/swh_legal.html
{% comment %}
# Copyright (C) 2025  The Software Heritage developers
# See the AUTHORS file at the top-level directory of this distribution
# License: GNU Affero General Public License version 3, or any later version
# See top-level LICENSE file for more information
{% endcomment %}

{% load i18n %}

<h4>{% translate "Applicable law" %}</h4>
{% blocktranslate trimmed %}
  <p>
    Software Heritage Archive is under the responsibility of <a href="https://inria.fr/en" rel="external">Inria</a>, France's National Institute for Research in Digital Science and Technology. Accordingly, French law is applicable.
  </p>
{% endblocktranslate %}
<h4>{% translate "Takedown notices" %}</h4>
{% blocktranslate trimmed %}
  <p>
    The Software Heritage archive collects publicly available source code, and its development history, from a variety of sources.
  </p>
  <p>
    Software Heritage does not perform any screening of the collected source code and development history, hence illicit content present therein may become part of the Software Heritage archive. In accordance with applicable French law, Software Heritage and Inria shall not be held liable for copyright infringement, provided they offer legitimate rights holders a viable process to request the removal of infringing content.
  </p>
  <p>
    <a href="https://www.softwareheritage.org/legal/content-policy/#takedown-notices"
       rel="external">Read more about takedown notices</a>
  </p>
{% endblocktranslate %}
<h4>{% translate "Personal data and name changes" %}</h4>
{% blocktranslate trimmed %}
  <p>
    People change their names and/or email addresses for many reasons. In cases covered in the <a href="https://www.softwareheritage.org/legal/content-policy/#personal-data"
    rel="external">GPDR information notice</a> established by Inria:
  </p>
  <ul>
    <li>
      If the main location for the source code has been updated, we can archive the updated code and remove what was previously archived. Access to copies of the same files from other source code location can be permanently restricted.
    </li>
    <li>
      When the main source code location cannot be updated we can hide all or part of the archived content and make name replacements on the fly.
    </li>
  </ul>
  <p>
    Rest assured that we want to preserve the dignity and safety of anyone who changes their name.
  </p>
  <p>
    Any processing of personal data will be carried out in compliance with the obligations related to the application of the GDPR only by accredited persons to do so on the appropriate channels.
  </p>
{% endblocktranslate %}
<h4>{% translate "Unauthorized changes" %}</h4>
{% blocktranslate trimmed %}
  <p>
    Unfortunately, malicious actors may try to exploit our archive alteration tools to manipulate historical records and remove legitimate content from the archive. For example:
  </p>
  <ul>
    <li>
      Request to remove an open-source version of the software after changing its license to a closed one.
    </li>
    <li>Request to delete or modify code written by others without proper authorization.</li>
  </ul>
  <p>
    To mitigate these risks, we have implemented a rigorous process for reviewing and approving all requests for archive changes. This includes verifying the original licensing of the source code, confirming its online availability, and may involve reviewing personal information provided by the requester.
  </p>
  <p>
    We must therefore apply a strict process to handle requests for changes to the archive, by verifying the licenses used to publish the source code, the online availability of the repository and sometimes personal information of the requester to ensure that the request is indeed valid.
  </p>
{% endblocktranslate %}